#include <Adafruit_CircuitPlayground.h>
#include <BlynkSimpleShieldEsp8266.h>

#define STATE_MORNING 0
#define STATE_AFTERNOON 1
#define STATE_NIGHT 2

int state = STATE_MORNING;
String p1 = "";
String p2 = "";
unsigned long previousMillis = 0;
unsigned long currentMillis = 0;
int interval = 1800000;
int cycle = -1;
int cycleTempSum = 0;
int temp = 0;
int sunny = 0 ; 
int rainy = 0 ;

void setup(){
 blynk_setup();
}

void loop(){
  run_blynk();
  currentMillis = millis();
  if (currentMillis - previousMillis >= interval)
  {
    previousMillis = currentMillis;
    cycle++;
    switch(state) {
      case STATE_MORNING:
        handle_morning();
        break;
      case STATE_AFTERNOON:
        handle_afternoon();
        break;
      case STATE_NIGHT:
        handle_night();
        break;
    }
  }
}

void handle_morning(){
  if (cycle == 0){ // if we are at the start of a new day
    Blynk.virtualWrite(V3, 42); // weatherWebhook
  }
  
  if (cycle > 0 && cycle % 15 == 0){ //if  8 hours have passed, check which part of the day we are on: morning, noon, night.
    state = 1;
    cycle = -1;
  }
  temp = CircuitPlayground.temperature();
  if(temp > 25){
    sunny++;
  }
  else{
    rainy++;
  }
  cycleTempSum += temp; 
}

void handle_afternoon(){
  if (cycle == 0){ // the time is now 5 PM, we gather today's measurments 
    p2 = (sunny >= rainy) ? "Yes" : "No" ; 
    p1 = cycleTempSum / 16;   
    Blynk.virtualWrite(V2, p1 ,p2);   //sensorWebhook
    sunny=0;
    rainy=0;
    cycleTempSum=0; 
  }
  if (cycle > 0 && cycle%15 == 0){ //if  8 hours have passed, check which part of the day we are on: morning, noon, night.
    state = 2;
    cycle = -1;
  }
}

void handle_night(){
  if (cycle > 0 && cycle%15 == 0) { //if  8 hours have passed, check which part of the day we are on: morning, noon, night.
    state = 0;
    cycle = -1;
  }
}
